// MultiConfig v1.1 - Copyright(C) 1994 by G. Veldman.
//-----
// I got the idea from PCM, and I had a few games that needed EMS and
// a few that needed XMS, and my dad wanted to have a configuration
// for himself, so I started programming this. It took me about 2 weeks
// to program it, and a few hours to test it.
// This program was written in C, but it's all BASIC-like C,
// so it's all very simple. This is because I'm only programming
// in C for a very little time, so there's a lot I don't know yet.
//-----
// You may freely distribute this source, in it's original form!!
//-----

#include <conio.h>
#include <dos.h>
#include <time.h>
#include <string.h>
#include <dir.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>

#define ALLCHARS 1
#define NOSPACE  2
#define FNAME    3
#define CAPITALS 4

#define BACKGROUNDCOLOR       0x71 // Background color
#define BRIGHTCOLOR           0x7F // Bright color(keys, countdown timer etc)
#define EDITWINDOWBRIGHTCOLOR 0x1F // Bright color when editing cfg. data
#define EDITWINDOWINPUTCOLOR  0x3E // Input color
#define EDITWINDOWTEXTCOLOR   0x13 // Normal text :'Autoexec.bat' etc.
#define EDITWINDOWTITLECOLOR  0x1E // Title when editing cfg. data
#define ERRORMSGCOLOR         0xFE // Error message color, same color as
                                   // status message, but blinking(+0x80)
#define KEYSCOLOR             0x7A // Help keys 'F1 - Use config' etc.
#define NAMECOLOR             0x7F // Program name color(Left top, right bottom)
#define NORMALCFGCOLOR        0x71 // Normal configuration
#define SELECTEDNORMAL        0x4A // Selected normal configuration
#define SELECTEDSTANDARD      0x4F // Selected standard configuration
#define STANDARDCFGCOLOR      0x79 // Standard configuration
#define STATUSMSGCOLOR        0x7E // Status message 'Waiting...'
#define TIMECOLOR             0x7F // Time color
#define TITLESCOLOR           0x7E // Titles : 'Description', 'Short name'

#define TRUE  1
#define FALSE !TRUE

#define ENTER     13
#define SPACE     32
#define BKSPC     8
#define ESC       27
#define UPARROW   72
#define DOWNARROW 80
#define F1        59
#define F2        60
#define DEL       83

#define INTERACTIVE 1
#define BATCH       2

#define UP   6
#define DOWN 7

unsigned int (far *screen)[80];
int specialkey=0;
time_t time1=0, time2=0;
FILE *cfg;
char configfile[MAXPATH];
char runpath[MAXPATH];
char rundrive[MAXDRIVE];
char rundir[MAXDIR];

struct {
        int configurations;
        int standard;
       } header;
             
struct {
        char autoexec_bat[MAXPATH];
        char config_sys[MAXPATH];
        char description[51];
        char short_name[17];
       } config[100];

void box(int x1, int y1, int x2, int y2, int color);
void buildeditscreen();
void checkconfigfile();
int checknumber(char *s);
void closefile();
int copy (char *from, char *to);
void createconfigfile();
void deleteitem(int itemnr);
int driveready(int drivenr);
void editconfig();
void editwindow(int cfgnr);
void errormessage(char *message);
int file_exists(char *filename);
int getpage();
void getrundir(char *fn);
int getyn();
void handletime();
void help();
void input(int accept, int x, int y, int inplen, int varlen, int color, int fillchar, char *var);
int readconfigfile();
void select(int l, int nr);
void scroll(int direction, int x1, int y1, int x2, int y2, int color);
void showconfig(int l, int nr);
void showstatus(char *status);
void showtime();
void unselect(int l, int nr);
void useconfiguration(int cfgnr, int mode);
int writeconfigfile();
void main(int argc, char *argv[]);

void box(int x1, int y1, int x2, int y2, int color)

{
 int count;
 if (x1>x2) return;
 if (y1>y2) return;

 for (count=x1;count<x2-1;count++)
  {
   screen[y1-1][count]=''+(color<<8);
   screen[y2-1][count]=''+(color<<8);
  }

 for (count=y1;count<y2-1;count++)
  {
   screen[count][x1-1]=''+(color<<8);
   screen[count][x2-1]=''+(color<<8);
  }

 screen[y1-1][x1-1]=''+(color<<8);
 screen[y1-1][x2-1]=''+(color<<8);
 screen[y2-1][x1-1]=''+(color<<8);
 screen[y2-1][x2-1]=''+(color<<8);
}

void buildeditscreen()

{
 int bgl;

 textmode(C80);
 textattr(BACKGROUNDCOLOR); window(1,1,80,25); clrscr();
 gotoxy(1,2);
 for (bgl=2;bgl<25;bgl++)
  cprintf("");
 window(23, 4, 57, 9); clrscr(); window(1,1,80,25);
 textattr(KEYSCOLOR);
 gotoxy(24, 4); cprintf("<F1>    - Use configuration");
 gotoxy(24, 5); cprintf("<F2>    - Save configuration file");
 gotoxy(24, 6); cprintf("<ESC>   - Exit MultiConfig");
 gotoxy(24, 7); cprintf("<DEL>   - Delete configuration");
 gotoxy(24, 8); cprintf("<ENTER> - Edit configuration");
 gotoxy(24, 9); cprintf("<SPACE> - Mark as standard"); 
 window(4, 11, 77, 22); clrscr(); window(1,1,80,25);
 textattr(TITLESCOLOR);
 gotoxy(5, 11); cprintf(" Description ");
 gotoxy(60, 11); cprintf(" Short name ");
 textattr(NAMECOLOR);
 gotoxy(2,1); cprintf("MultiConfig v1.1 by G. Veldman");
 gotoxy(69, 25); cprintf("MultiConfig");
 textattr(NAMECOLOR&240); gotoxy(67, 25); cprintf("");
 showstatus("Waiting...");
 showtime();
 box(22, 3, 58, 10, BRIGHTCOLOR);
 box(3, 10, 78, 23, BRIGHTCOLOR);
 screen[9][21]=(BRIGHTCOLOR<<8)+0xCA;
 screen[9][57]=(BRIGHTCOLOR<<8)+0xCA;
}

void checkconfigfile()

{
 char buffer[40];
 int key;

 if (!file_exists(configfile))
  {
   printf("MultiConfig's configuration file does not exist. Create it? [Y/N]");
   key=getyn(); printf("\n\n");
   switch(key)
    {
     case 'Y': createconfigfile();
               return;
     case 'N': printf("Sorry, MultiConfig can't run without it's configuration file.\n");
               exit(1);
    } 
  }
 cfg=fopen(configfile, "rb");
 if (cfg==NULL)
  {
   printf("Could not open MultiConfig's configuration file.\n");
   exit(1);
  }

 if (fread(&buffer, 39, 1, cfg) != 1)
  {
   fclose(cfg);
   printf("MultiConfig's configuration file is damaged. Re-create it? [Y/N]");
   key=getyn(); printf("\n\n");
   switch(key)
    {
     case 'Y': createconfigfile();
               return;
     case 'N': printf("Sorry, MultiConfig can't run without it's configuration file.\n");
               exit(1);
    } 
  }

 if (fread(&header, sizeof(header), 1, cfg) != 1)
  {
   fclose(cfg);
   printf("MultiConfig's configuration file is damaged. Re-create it? [Y/N]");
   key=getyn(); printf("\n\n");
   switch(key)
    {
     case 'Y': createconfigfile();
               return;
     case 'N': printf("Sorry, MultiConfig can't run without it's configuration file.\n");
               exit(1);
    } 
  }
 fclose(cfg);
}

int checknumber(char *s)

{
 int sp=0;

 while (isdigit(s[sp++]));
 if (sp-1<strlen(s))
  return 0;
 else
  return 1;
}

void closefile()

{
 fclose(cfg);
}

int copy (char *from, char *to)

{
 /* Returns: 0 - No errors
             1 - Error in FROM-file
             2 - Error in TO-file
 */
 int ch;
 ldiv_t parts;
 unsigned long size;
 unsigned long blockcount;
 int number;
 char buffer[32768L];
 int infile;
 int outfile;

 // if 'to'-file exists, delete it
 if (file_exists(to))
  {
   _chmod(to, 1, 0);
   unlink(to);
  }

 // Open 'from'-file

 infile=open(from, O_RDONLY | O_BINARY);
 if (infile==-1) return 1;
 outfile=open(to, O_CREAT | O_BINARY);
 if (outfile==-1)
  {
   close(infile);
   return 2;
  }
 size=filelength(infile);

 parts=ldiv(size,32768L);

 // Start copying
 blockcount=0;
 while (blockcount<parts.quot)
  {
   if (read(infile, buffer, (unsigned int)32768L) == -1) 
    {
     close(infile); close(outfile);
     return 1;
    }
   if (write(outfile, buffer, (unsigned int)32768L) == -1)
    {
     close(infile); close(outfile);
     return 2;
    }
   blockcount++;
  }
 if (read(infile, buffer, (unsigned int)parts.rem) == -1)
  {                                                   
   close(infile); close(outfile);
   return 1;
  }
 if (write(outfile, buffer, (unsigned int)parts.rem) == -1)
  {
   close(infile); close(outfile);
   return 2;
  }
 close(infile); close(outfile);
 _chmod(to, 1, 0);
 return 0;
}

void createconfigfile()

{
 int auto_exists=FALSE, config_exists=FALSE;
 int result;
 // This function creates a brand new configuration file.

 strcpy(config[0].autoexec_bat,"**None**");
 strcpy(config[0].config_sys, "**None**");
 strcpy(config[0].description, "Clean boot");
 strcpy(config[0].short_name, "CLEAN");

 strcpy(config[1].autoexec_bat, "**None**");
 strcpy(config[1].config_sys, "**None**");
 strcpy(config[1].description, "Standard configuration");
 strcpy(config[1].short_name, "STANDARD");

 header.configurations=1;
 header.standard=-1;
 if (file_exists("C:\\AUTOEXEC.BAT"))
  auto_exists=TRUE;
 if (file_exists("C:\\CONFIG.SYS"))
  config_exists=TRUE;

 if ((auto_exists==TRUE) || (config_exists==TRUE))
  {
   if (auto_exists)
    {
     if (copy("C:\\AUTOEXEC.BAT", "C:\\AUTOEXEC.STD"))
      goto create_file;
     strcpy(config[1].autoexec_bat, "C:\\AUTOEXEC.STD");
    }
   if (config_exists)
    {
     if (copy("C:\\CONFIG.SYS", "C:\\CONFIG.STD"))
      goto create_file;
     strcpy(config[1].config_sys, "C:\\CONFIG.STD");
    }
   header.configurations=2;
   header.standard=1;
  }

create_file:;
 result=writeconfigfile();
 if (result)
  {
   printf("Error creating configuration file. The disk may be full.\n");
   exit(1);
  }
}

void deleteitem(int itemnr)

{
 int itemcount;

 if (itemnr>header.configurations-1) return;

 if (itemnr<header.standard) 
  header.standard--;
 else
  if (itemnr==header.standard)
   header.standard=-1;

 for (itemcount=itemnr+1;itemcount<header.configurations;itemcount++)
  config[itemcount-1]=config[itemcount];
 header.configurations--;
 strcpy(config[header.configurations].autoexec_bat,"");
 strcpy(config[header.configurations].config_sys,"");
 strcpy(config[header.configurations].description, "");
 strcpy(config[header.configurations].short_name, "");
}

int driveready(int drivenr)

{
 union REGS inregs, outregs;
 struct SREGS sregs;
 char buf[2048];

 // Try reading from disk drive. If drivenr=HDD, then nothing happens!
 inregs.h.ah = 2;
 inregs.h.dl = drivenr;
 inregs.h.dh = 0;
 inregs.h.ch = 1;
 inregs.h.cl = 1;
 inregs.h.al = 1;
 sregs.es = FP_SEG(&buf);
 inregs.x.bx = FP_OFF(&buf);
 int86x(0x13, &inregs, &outregs, &sregs);

 if (outregs.h.ah==0x80) return 1;
 return 0;
}

void editconfig()

{
 int cfgnr,
     quit=FALSE,
     ch,
     wstart=0,
     cfgline=0,
     temp;

 buildeditscreen();
 if (header.configurations < 12)
  {
   for (cfgnr=0;cfgnr<header.configurations;cfgnr++)
    showconfig(cfgnr+12, cfgnr);
  }
 else
  {
   for (cfgnr=0;cfgnr<11;cfgnr++)
    showconfig(cfgnr+12, cfgnr);
  }
 _setcursortype(_NOCURSOR);
 select(12, 0);

 while(!quit)
  {
   ch=getch();
   switch(ch)
    {
     case ENTER: // Enter, Edit configuration data
                 showstatus("Editing configuration data...");
                 editwindow(wstart+cfgline); 
                 showconfig(cfgline+12, wstart+cfgline);
                 select(cfgline+12, wstart+cfgline);
                 showstatus("Waiting...");
                 break;
     case SPACE: // Space, mark as standard
                 if (wstart+cfgline==header.configurations) break;
                 if ((wstart<=header.standard) && (header.standard<wstart+11))
                  {
                   if (header.standard==wstart+cfgline)
                    {
                     header.standard=-1;
                     select(cfgline+12, wstart+cfgline);
                    }
                   else
                    {
                     temp=header.standard;
                     header.standard=wstart+cfgline;
                     showconfig(12+temp-wstart, temp);
                     select(cfgline+12, header.standard);
                    }
                  }
                 else
                  {
                   if (header.standard==wstart+cfgline)
                    {
                     header.standard=-1;
                     select(cfgline+12, wstart+cfgline);
                    }
                   else
                    {
                     header.standard=wstart+cfgline;
                     select(cfgline+12, wstart+cfgline);
                    }
                  }
                 break;
     case ESC  : // ESC, quit
                 quit=TRUE; break;
    }
   if (ch==0)
    {
     ch=getch();
     switch(ch)
      {
       case UPARROW  : if (wstart+cfgline==0) break;
                       unselect(12+cfgline, wstart+cfgline);
                       if ((wstart>0) && (cfgline==0))
                        {
                         scroll(DOWN, 6, 12, 76, 22, TITLESCOLOR);
                         wstart--;
                         showconfig(12, wstart);
                        }
                       else
                        cfgline--;
                       select(12+cfgline, wstart+cfgline);
                       break;
       case DOWNARROW: if (wstart+cfgline==header.configurations) break;
                       unselect(12+cfgline, wstart+cfgline);
                       if (cfgline==10)
                        {
                         scroll(UP, 6, 12, 76, 22, TITLESCOLOR);
                         wstart++;
                         if (wstart+cfgline-1!=header.configurations)
                          showconfig(22, wstart+cfgline);
                        }
                       else
                        cfgline++;
                       select(12+cfgline, wstart+cfgline);
                       break;
       case F1       : // Use configuration
                      if (wstart+cfgline==header.configurations)
                       {
                        errormessage("Can't use empty configuration. Press a key...");
                        break;
                       }
                      showstatus("Use configuration...");
                      useconfiguration(wstart+cfgline, INTERACTIVE);
                      showstatus("Waiting...");
                      break;
       case F2      : // Save configuration file
                      showstatus("Writing configuration file...");
                      if (writeconfigfile())
                       {
                        errormessage("Error writing config file. Press a key...");
                        showstatus("Waiting...");
                        break;
                       }
                      showstatus("Waiting...");
                      break;
       case DEL     : // Delete configuration
                      if (header.configurations == 0) break;
                      if (wstart+cfgline==header.configurations) break;
                      unselect(cfgline+12, wstart+cfgline);
                      deleteitem(wstart+cfgline);
                      if (wstart > 0)
                       {
                        scroll(DOWN, 6, 12, 76, cfgline+12, TITLESCOLOR);
                        wstart--;
                        showconfig(12, wstart);
                       }
                      else
                       {
                        scroll(UP, 6, cfgline+12, 76, 22, TITLESCOLOR);
                        if (wstart+10 <=header.configurations)
                         showconfig(22, wstart+10);
                        if ((wstart+cfgline > header.configurations-1) && (header.configurations!=0))
                         cfgline--;
                       }
                      select(cfgline+12, wstart+cfgline);
                      break;
      }
    }
  }
 // ESC pressed(quit=TRUE)

 _setcursortype(_NORMALCURSOR);

 textattr(0x07);
 clrscr();
 printf("Goodbye...\n\n");
 exit(0);
}

void editwindow(int cfgnr)

{
 char buffer[2000];
 char autoexec_bat[MAXPATH];
 char config_sys[MAXPATH];
 char description[53];
 char short_name[19];

 gettext(14, 8, 66, 17, buffer);
 textattr(EDITWINDOWTITLECOLOR);
 window(14, 8, 66, 17); clrscr(); window(1,1,80,25);
 gotoxy(16, 9); cprintf("Configuration data for configuration");
 gotoxy(15, 10); cprintf("");
 gotoxy(16, 16); cprintf("Press F2 to accept, press ESC to exit");
 textattr(EDITWINDOWBRIGHTCOLOR);
 gotoxy(53, 9); cprintf("%d", cfgnr+1);
 gotoxy(22, 16); cprintf("F2");
 gotoxy(42, 16); cprintf("ESC");
 textattr(EDITWINDOWTEXTCOLOR);
 gotoxy(16, 11); cprintf("Autoexec.bat :");
 gotoxy(16, 12); cprintf("Config.sys   :");
 gotoxy(16, 13); cprintf("Description  :");
 gotoxy(16, 14); cprintf("Short name   :");
 if (strcmp(config[cfgnr].autoexec_bat, "**None**") == 0)
  strcpy(autoexec_bat, "");
 else
  strcpy(autoexec_bat, config[cfgnr].autoexec_bat);
 if (strcmp(config[cfgnr].config_sys, "**None**") == 0)
  strcpy(config_sys, "");
 else
  strcpy(config_sys, config[cfgnr].config_sys);

 strcpy(description, config[cfgnr].description);
 strcpy(short_name, config[cfgnr].short_name);

 textattr(EDITWINDOWINPUTCOLOR);
 window(31, 11, 64, 13); clrscr(); window(1,1,80,25);
 window(31, 14, 46, 14); clrscr(); window(1,1,80,25);
 gotoxy(31, 11); cprintf("%-.34s", autoexec_bat);
 gotoxy(31, 12); cprintf("%-.34s", config_sys);
 gotoxy(31, 13); cprintf("%-.34s", description);
 gotoxy(31, 14); cprintf("%-.16s", short_name);

 _setcursortype(_NORMALCURSOR);

get_autoexec:;
 input(FNAME, 31, 11, 34, 126, EDITWINDOWINPUTCOLOR, '', autoexec_bat);
 if (autoexec_bat[0] == 27) goto back;
 if (specialkey!=0)
  {
   switch(specialkey)
    {
     case 72: goto get_short;
     case 60: goto accept;
    }
   specialkey=0;
  }
get_config:;
 input(FNAME, 31, 12, 34, 126, EDITWINDOWINPUTCOLOR, '', config_sys);
 if (config_sys[0] == 27) goto back;
 if (specialkey!=0)
  {
   switch(specialkey)
    {
     case 72: goto get_autoexec;
     case 60: goto accept;
    }
   specialkey=0;
  }
get_descr:;
 input(ALLCHARS, 31, 13, 34, 50, EDITWINDOWINPUTCOLOR, '', description);
 if (description[0] == 27) goto back;
 if (specialkey!=0)
  {
   switch(specialkey)
    {
     case 72: goto get_config;
     case 60: goto accept;
    }
   specialkey=0;
  }
get_short:;
 input(CAPITALS, 31, 14, 16, 16, EDITWINDOWINPUTCOLOR, '', short_name);
 if (short_name[0] == 27) goto back;
 if (specialkey!=0)
  {
   switch(specialkey)
    {
     case 72: goto get_descr;
     case 60: goto accept;
    }
   specialkey=0;
  }
 goto get_autoexec;
accept:;
 puttext(14, 8, 66, 17, buffer);
 _setcursortype(_NOCURSOR);

 if (header.configurations-1==cfgnr)
  if (strlen(autoexec_bat) == 0)
   if (strlen(config_sys) == 0)
    if (strlen(description) == 0)
     if (strlen(short_name) == 0)
      if (header.configurations != 0)
       {
        header.configurations--;
        strcpy(config[cfgnr].autoexec_bat, "");
        strcpy(config[cfgnr].config_sys, "");
        strcpy(config[cfgnr].description, "");
        strcpy(config[cfgnr].short_name, "");

        goto back;
       }

 if (header.configurations==cfgnr)
  {
   if (strlen(autoexec_bat) == 0)
    if (strlen(config_sys) == 0)
     if (strlen(description) == 0)
      if (strlen(short_name) == 0)
       goto cont;

   if (header.configurations < 100) header.configurations++;
  }

cont:;

 if (strlen(autoexec_bat) == 0)
  strcpy(config[cfgnr].autoexec_bat, "**None**");
 else
  strcpy(config[cfgnr].autoexec_bat, autoexec_bat);

 if (strlen(config_sys) == 0)
  strcpy(config[cfgnr].config_sys, "**None**");
 else
  strcpy(config[cfgnr].config_sys, config_sys);

 if (strlen(description) == 0)
  strcpy(config[cfgnr].description, "(No description)");
 else
  strcpy(config[cfgnr].description, description);

 if (strlen(short_name) == 0)
  sprintf(config[cfgnr].short_name, "CONFIG%.03d", cfgnr+1);
 else
  strcpy(config[cfgnr].short_name, short_name);

 if ((cfgnr==header.configurations) && (header.configurations<100))
  header.configurations++;
   
back:;
 puttext(14, 8, 66, 17, buffer);
 _setcursortype(_NOCURSOR);
 return;
}

void errormessage(char *message)

{
 textattr(ERRORMSGCOLOR);

 window(1, 25, 65, 25); clrscr(); window(1,1,80,25);
 gotoxy(2,25); cprintf("%s", message);
 if (getch() == 0) getch();
 
 textattr(STATUSMSGCOLOR);
 window(1,25,65,25); clrscr(); window(1,1,80,25);
 gotoxy(2,25); cprintf("Waiting...");
}

int file_exists(char *filename)

{
 return (access(filename, 0) == 0);
}

int getpage()

{
 union REGS regs;

 regs.h.ah = 0x0F;
 int86(0x10, &regs, &regs);
 return ((regs.h.al == 7) ? 0xB000 : 0xB800);
}

void getrundir(char *fn)

{
 char drive[MAXDRIVE];
 char dir[MAXDIR];
 char file[MAXFILE];
 char ext[MAXEXT];
 
 fnsplit(fn, drive, dir, file, ext);

 fnmerge(configfile, drive, dir, "MULTICNF", ".CFG");
 strcpy(rundrive, drive);
 strcpy(rundir, dir);
 sprintf(runpath, "%s%s", drive, dir);
 runpath[strlen(runpath)-1]=0; // Remove '\' at end of string
}

int getyn()

{
 int key;
 printf(" [ ]");
 gotoxy(wherex()-2, wherey());
get_key:;
 key=getche();
 if (key==0)
  {
   getch();
   goto get_key;
  }
 if (toupper(key) == 'Y') return 'Y';
 if (toupper(key) == 'N') return 'N';
 goto get_key;
}

void handletime()

{
 int oldx, oldy;

 oldx=wherex(); oldy=wherey();
 time2=time(NULL);
 if (time2-time1 >= 5)
  {
   showtime();
   time1=time(NULL);
   time2=time(NULL);
  }
 gotoxy(oldx, oldy);
}

void help()

{
 printf("  Usage: CONFIG [Config-nr or Short name] [/R] [/?] [/L]\n\n");
 printf("         /? - This help\n");
 printf("         /R - Restart, rewrite configuration file. All configurations\n"); 
 printf("              are lost!\n\n");
 printf("         /L - List all configurations\n");
 printf("         Specify the configuration number, or it's short name to reboot\n");
 printf("         using that configuration.\n\n");
 printf("         Start without parameters to edit configurations\n\n"); 
}

void input(int accept, int x, int y, int inplen, int varlen, int color, int fillchar, char *var)

{
 int start=0;
 int cc;
 int ch;
 int charnr=0;

 gotoxy(x,y); textattr(color);
 for (cc=0;cc<inplen;cc++)
  screen[y-1][x-1+cc]=(fillchar+(color<<8));
 gotoxy(x,y);
 if (strlen(var) > inplen)
  {
   if (strlen(var)!=varlen)
    {
     start=strlen(var)-inplen+1;
     charnr=inplen-1;
     cprintf("%s", var+start);  
    }
   else
    {
     start=strlen(var)-inplen;
     charnr=inplen-1;
     cprintf("%s", var+start);
     gotoxy(wherex()-1, wherey());
    }
  }
 else
  {
   cprintf("%s", var);
   charnr=strlen(var);
   if (strlen(var)==inplen) gotoxy(wherex()-1, wherey());
  }

get_ch:;
 while (!kbhit())
  {
   handletime();
   textattr(color);
  }
 ch=getch();
 if (ch==0)
  {
   ch=getch();
   switch(ch)
    {
     case 72: specialkey=72;
              textattr(color); window(x,y,x+inplen-1,y); clrscr(); window(1,1,80,25);
              gotoxy(x,y); cprintf("%-.34s", var);
              return;
     case 80: specialkey=80;
              textattr(color); window(x,y,x+inplen-1,y); clrscr(); window(1,1,80,25);
              gotoxy(x,y); cprintf("%-.34s", var);
              return;
     case 60: specialkey=60;
              textattr(color); window(x,y,x+inplen-1,y); clrscr(); window(1,1,80,25);
              gotoxy(x,y); cprintf("%-.34s", var);
              return;
    }
   goto get_ch;
  }
 switch(ch)
  {
   case ENTER: specialkey=0;
               textattr(color); window(x,y,x+inplen-1,y); clrscr(); window(1,1,80,25);
               gotoxy(x,y); cprintf("%-.34s", var);
               return;
   case ESC  : var[0]=27; var[1]=0; return;
   case BKSPC: if (start+charnr==0) goto get_ch;
               if (start>0)
                {
                 if (start+charnr+1==varlen)
                  {
                   if (var[start+charnr]!=0)
                    {
                     gotoxy(x+charnr, y); cprintf("%c", fillchar);
                     var[start+charnr]=0;
                     gotoxy(x+charnr, y);
                     goto get_ch;
                    }
                  }
                 start--;
                 gotoxy(x,y);
                 var[start+charnr]=0;
                 cprintf("%s%c", var+start, fillchar);
                 gotoxy(x+charnr, y);
                 goto get_ch;
                }

               // Standard
               if (start+charnr+1==varlen)
                {
                 if (var[start+charnr]!=0)
                  {
                   gotoxy(x+charnr, y); cprintf("%c", fillchar);
                   var[start+charnr]=0;
                   gotoxy(x+charnr, y);
                   goto get_ch;
                  }
                }
               var[start+charnr-1]=0;
               charnr--;
               gotoxy(x+charnr, y);
               cprintf("%c", fillchar);
               gotoxy(x+charnr, y);
               goto get_ch;
  }
 switch(accept)
  {
   case ALLCHARS : break;
   case NOSPACE  : if (ch==32) goto get_ch;
                   break;
   case FNAME    : if ((ch<33)||(ch==62)||(ch==60)||(ch==42)||(ch==44)||(ch==43)||(ch==34)||(ch==59)||(ch==94)||(ch==124)) goto get_ch;
                   break;
   case CAPITALS : ch=toupper(ch);
                   break;
  }

 if (start+charnr+1==varlen)
  {
   cprintf("%c", ch);
   var[start+charnr]=ch; var[start+charnr+1]=0;
   gotoxy(x+charnr, y);
   goto get_ch;
  }
 if (charnr+1==inplen)
  {
   if (start+charnr+1!=varlen)
    {
     gotoxy(x,y); cprintf("%s", var+start+1);
     gotoxy(x+charnr-1,y);
     var[start+charnr]=ch; var[start+charnr+1]=0;
     cprintf("%c%c", ch, fillchar);
     gotoxy(x+charnr,y);
     start++;
     goto get_ch;
    }
  }
 cprintf("%c", ch);
 var[start+charnr]=ch; var[start+charnr+1]=0;
 charnr++;
 goto get_ch;
}

int readconfigfile()

{
 /* Returns: 0 - No errors
             1 - Error opening/reading configuration file
 */

 char buffer[40];
 int cfg_nr;

 cfg=fopen(configfile, "rb");
 if (cfg==NULL)
  return 1;

 if (fread(&buffer, 39, 1, cfg) != 1)
  return 1;

 if (fread(&header, sizeof(header), 1, cfg) != 1)
  return 1;

 for (cfg_nr=0;cfg_nr<header.configurations;cfg_nr++)
  {
   if (fread(&config[cfg_nr], sizeof(config[0]), 1, cfg) != 1)
    return 1;
  }

 closefile();
 return 0;
}

void select(int l, int nr)

{
 int count;
 int color;

 if (nr==header.standard)
  color=SELECTEDSTANDARD;
 else
  color=SELECTEDNORMAL;
  
 for (count=4;count<76;count++)
  screen[l-1][count]=(screen[l-1][count]&255)+(color<<8);
}

void scroll(int direction, int x1, int y1, int x2, int y2, int color)

{
 union REGS regs;

 regs.h.ah=direction;
 regs.h.al=1;
 regs.h.ch=y1-1;
 regs.h.cl=x1-1;
 regs.h.dh=y2-1;
 regs.h.dl=x2-1;
 regs.h.bh=color;
 int86(0x10, &regs, &regs);
}

void showconfig(int l, int nr)

{
 textattr(NORMALCFGCOLOR); window(4, l, 77, l); clrscr(); window(1,1,80,25);
 if (nr==header.standard) textattr(STANDARDCFGCOLOR);
 gotoxy(6, l); cprintf("%-.50s", config[nr].description);
 gotoxy(60,l); cprintf("%-.16s", config[nr].short_name);
}

void showstatus(char *status)

{
 textattr(STATUSMSGCOLOR); window(2,25,65,25); clrscr(); window(1,1,80,25);
 gotoxy(2,25); cprintf("%s", status);
}

void showtime()

{
 struct time t;

 gettime(&t);
 textattr(TIMECOLOR);
 if (t.ti_hour>9)
  gotoxy(74, 1);
 else
  gotoxy(73, 1);
 cprintf("%2d:%02d", t.ti_hour, t.ti_min);
}

void unselect(int l, int nr)

{
 int count;
 int color;

 if (nr==header.standard)
  color=STANDARDCFGCOLOR;
 else
  color=NORMALCFGCOLOR;
  
 for (count=4;count<76;count++)
  screen[l-1][count]=(screen[l-1][count]&255)+(color<<8);
}

void useconfiguration(int cfgnr, int mode)

{
 char buffer[2000];
 time_t start, end;
 int olddiff, diff;
 char drive[MAXDRIVE];
 char mess[80];

 if (mode==INTERACTIVE)
  {
   gettext(10, 8, 71, 17, buffer);
   copy("C:\\AUTOEXEC.BAT", "C:\\AUTOEXEC.MC");
   copy("C:\\CONFIG.SYS", "C:\\CONFIG.MC");
   _chmod("C:\\AUTOEXEC.BAT", 1, FA_ARCH);
   _chmod("C:\\CONFIG.SYS", 1, FA_ARCH);
   unlink("C:\\AUTOEXEC.BAT");
   unlink("C:\\CONFIG.SYS");
   fnsplit(config[cfgnr].autoexec_bat, drive, 0, 0, 0);
   if(driveready(drive[0]-'A'))
    {
     sprintf(mess, "Drive %c not ready!", toupper(drive[0]));
     errormessage(mess);
     return;
    }
   if (strcmp(config[cfgnr].autoexec_bat, "**None**") != 0)
    {
     if (!file_exists(config[cfgnr].autoexec_bat))
      {
       errormessage("Autoexec.bat replacement does not exist!");
       copy("C:\\AUTOEXEC.MC", "C:\\AUTOEXEC.BAT");
       copy("C:\\CONFIG.MC", "C:\\CONFIG.SYS");
       return;
      }
     if (copy(config[cfgnr].autoexec_bat, "C:\\AUTOEXEC.BAT")) 
      {
       errormessage("Error copying autoexec.bat to C:\\");
       copy("C:\\AUTOEXEC.MC", "C:\\AUTOEXEC.BAT");
       copy("C:\\CONFIG.MC", "C:\\CONFIG.SYS");
       return;
      }
    }
   fnsplit(config[cfgnr].config_sys, drive, 0, 0, 0);
   if(driveready(drive[0]-'A'))
    {
     sprintf(mess, "Drive %c not ready!", toupper(drive[0]));
     errormessage(mess);
     return;
    }
   if (strcmp(config[cfgnr].config_sys, "**None**") != 0)
    {
     if (!file_exists(config[cfgnr].config_sys))
      {
       errormessage("Config.sys replacement does not exist!");
       copy("C:\\AUTOEXEC.MC", "C:\\AUTOEXEC.BAT");
       copy("C:\\CONFIG.MC", "C:\\CONFIG.SYS");
       return;
      }
     if (copy(config[cfgnr].config_sys, "C:\\CONFIG.SYS"))
      {
       errormessage("Error copying config.sys to C:\\");
       copy("C:\\AUTOEXEC.MC", "C:\\AUTOEXEC.BAT");
       copy("C:\\CONFIG.MC", "C:\\CONFIG.SYS");
       return;
      }
    }
   // Files copied. Show message and, if not aborted, reboot
   textattr(EDITWINDOWTITLECOLOR); window(10, 8, 71, 17); clrscr(); window(1,1,80,25);
   gotoxy(12, 9); cprintf("Rebooting using configuration");
   if (cfgnr==header.standard)
    {
     gotoxy(46, 9);
     cprintf("(Standard configuration)");
    }
   gotoxy(11, 10); cprintf("");
   gotoxy(12, 16); cprintf("Timer:");
   gotoxy(24, 16); cprintf("Press ESC to abort, any other key to reboot...");
   textattr(EDITWINDOWBRIGHTCOLOR);
   gotoxy(42, 9); cprintf("%d", cfgnr+1);
   gotoxy(19, 16); cprintf("05");
   gotoxy(30, 16); cprintf("ESC");
   textattr(EDITWINDOWTEXTCOLOR);
   gotoxy(12, 11); cprintf("Description  :");
   gotoxy(12, 12); cprintf("Short name   :");
   gotoxy(12, 13); cprintf("Autoexec.bat :");
   gotoxy(12, 14); cprintf("Config.sys   :");
   if ((EDITWINDOWTEXTCOLOR&15) < 8) 
    textattr(EDITWINDOWTEXTCOLOR+0x08);
   gotoxy(27, 11); cprintf("%-.43s", config[cfgnr].description);
   gotoxy(27, 12); cprintf("%-.16s", config[cfgnr].short_name);
   gotoxy(27, 13); 
   if (strcmp(config[cfgnr].autoexec_bat, "**None**")==0)
    cprintf("(No autoexec)");
   else
    cprintf("%-.43s", config[cfgnr].autoexec_bat);
   gotoxy(27, 14);
   if (strcmp(config[cfgnr].autoexec_bat, "**None**")==0)
    cprintf("(No config)");
   else
    cprintf("%-.43s", config[cfgnr].config_sys);
   textattr(EDITWINDOWBRIGHTCOLOR);
   start=time(NULL);
   end=time(NULL);
   while ((end-start!=5) && (!kbhit()))
    {
     gotoxy(19, 16);
     cprintf("%02d", 5-end+start);
     end=time(NULL);
    }
   if (kbhit())
    {
     switch(getch())
      {
       case 27: copy("C:\\AUTOEXEC.MC", "C:\\AUTOEXEC.BAT");
                copy("C:\\CONFIG.MC", "C:\\CONFIG.SYS");
                puttext(10, 8, 71, 17, buffer);
                return;
       case  0: getch();
      }
    } 
   gotoxy(19, 16); cprintf("00");
   puttext(10, 8, 71, 17, buffer);
   textattr(EDITWINDOWBRIGHTCOLOR);
   window(15, 8, 66, 14); clrscr(); window(1,1,80,25);
   gotoxy(17, 9); cprintf("If your PC does not reboot after a few seconds,");
   gotoxy(17,10); cprintf("try pressing <CTRL>-<ALT>-<DEL>, if this doesn't");
   gotoxy(17,11); cprintf("work either, press RESET or turn your PC off and");
   gotoxy(17,12); cprintf("back on. It will now reboot using the new");
   gotoxy(17,13); cprintf("configuration.");
  
   // Reboot:
   __emit__(0xB8,0x10,0x4A,0xBB,0x00,0x00,0xCD,0x2F,0x3D,0xBE,0xBA,
            0x75,0x08,0xB8,0x10,0x4A,0xBB,0x02,0x00,0xCD,0x2F,0xEA,
            0x00,0x00,0xFF,0xFF);
   exit(0);

  }
 else
  {
   copy("C:\\AUTOEXEC.BAT", "C:\\AUTOEXEC.MC");
   copy("C:\\CONFIG.SYS", "C:\\CONFIG.MC");
   _chmod("C:\\AUTOEXEC.BAT", 1, FA_ARCH);
   _chmod("C:\\CONFIG.SYS", 1, FA_ARCH);
   unlink("C:\\AUTOEXEC.BAT");
   unlink("C:\\CONFIG.SYS");
   fnsplit(config[cfgnr].autoexec_bat, drive, 0, 0, 0);
   if(driveready(drive[0]-'A'))
    {
     printf("Drive %c not ready!", toupper(drive[0]));
     exit(1);
    }
   if (strcmp(config[cfgnr].autoexec_bat, "**None**") != 0)
    {
     if (!file_exists(config[cfgnr].autoexec_bat))
      {
       printf("Autoexec.bat: %s does not exist!\n", config[cfgnr].autoexec_bat);
       exit(1);
      }
     if (copy(config[cfgnr].autoexec_bat, "C:\\AUTOEXEC.BAT"))
      {
       printf("Error copying autoexec.bat to C:\\\n");
       copy("C:\\AUTOEXEC.MC", "C:\\AUTOEXEC.BAT");
       copy("C:\\CONFIG.MC", "C:\\CONFIG.SYS");
       return;
      }
    }
   fnsplit(config[cfgnr].config_sys, drive, 0, 0, 0);
   if(driveready(drive[0]-'A'))
    {
     printf("Drive %c not ready!\n", toupper(drive[0]));
     exit(1);
    }
   if (strcmp(config[cfgnr].config_sys, "**None**") != 0)
    {
     if (!file_exists(config[cfgnr].config_sys))
      {
       printf("Config.sys: %s does not exist!\n", config[cfgnr].config_sys);
       exit(1);
      }
     if (copy(config[cfgnr].config_sys, "C:\\CONFIG.SYS"))
      {
       printf("Error copying config.sys to C:\\\n");
       copy("C:\\AUTOEXEC.MC", "C:\\AUTOEXEC.BAT");
       copy("C:\\CONFIG.MC", "C:\\CONFIG.SYS");
       return;
      }
    }
   // Files copied. Show message and, if not aborted, reboot
   cprintf("Rebooting using configuration %d\n\r\n", cfgnr+1);
   cprintf("Description  : ");
   textattr(0x0F); cprintf("%-.43s\n\r", config[cfgnr].description);
   textattr(0x07); cprintf("Short name   : ");
   textattr(0x0F); cprintf("%-.16s\n\r", config[cfgnr].short_name);
   textattr(0x07); cprintf("Autoexec.bat : ");
   textattr(0x0F);
   if (strcmp(config[cfgnr].autoexec_bat, "**None**")==0)
    cprintf("(No autoexec)\n\r");
   else
    cprintf("%-.43s\n\r", config[cfgnr].autoexec_bat);   
   textattr(0x07); cprintf("Config.sys   : ");
   textattr(0x0F); 
   if (strcmp(config[cfgnr].config_sys, "**None**")==0)
    cprintf("(No config)\n\r");
   else
    cprintf("%-.43s\n\r\n", config[cfgnr].config_sys);
   textattr(0x07); cprintf("Timer: ");
   textattr(0x0F); cprintf("05");
   textattr(0x07); cprintf(", Press ESC to abort, press a key to reboot.");
   gotoxy(10, wherey()); textattr(0x0F);

   start=time(NULL);
   end=time(NULL);
   olddiff=0;
   while ((end-start!=5) && (!kbhit()))
    {
     diff=(unsigned int)(end-start);
     if (diff!=olddiff)
      {
       gotoxy(wherex()-2, wherey());
       cprintf("%02d", 5-diff);
       olddiff=diff;
      }
     end=time(NULL);
    }
   textattr(0x07);
   if (kbhit())
    {
     switch(getch())
      {
       case 27: copy("C:\\AUTOEXEC.MC", "C:\\AUTOEXEC.BAT");
                copy("C:\\CONFIG.MC", "C:\\CONFIG.SYS");
                printf("\n\nABORTED!\n\n");
                exit(0);
       case  0: getch();
      }
    } 
   gotoxy(wherex()-2, wherey()); cprintf("00\n\r\n");
   cprintf("If your PC does not reboot after a few seconds,\n\r");
   cprintf("try pressing ");
   textattr(0x0F); cprintf("<CTRL>-<ALT>-<DEL>");
   textattr(0x07); cprintf(", if this doesn't\n\r");
   cprintf("work either, press ");
   textattr(0x0F); cprintf("RESET");
   textattr(0x07); cprintf(" or turn your PC off and\n\r");
   cprintf("back on. It will now reboot using the new\n\r");
   cprintf("configuration.\n\r\n");
  
   // Reboot:
   __emit__(0xB8,0x10,0x4A,0xBB,0x00,0x00,0xCD,0x2F,0x3D,0xBE,0xBA,
            0x75,0x08,0xB8,0x10,0x4A,0xBB,0x02,0x00,0xCD,0x2F,0xEA,
            0x00,0x00,0xFF,0xFF);
   exit(0);
  }
}

int writeconfigfile()

{
 /* Returns: 0 - No errors
             1 - Error opening/reading file.
 */

 int cfg_nr;

 // Open MULTICNF.CFG
 cfg=fopen(configfile, "wb");
 if (cfg==NULL)
  return 1;

 if (fwrite("MultiConfig v1.1 configuration file.\n\r\x1A", 39, 1, cfg) != 1)
  return 1;

 if (fwrite(&header, sizeof(header), 1, cfg) != 1)
  {
   closefile();
   return 1;
  }

 for (cfg_nr=0;cfg_nr<header.configurations;cfg_nr++)
  {
   if (fwrite(&config[cfg_nr], sizeof(config[0]), 1, cfg) != 1)
    {
     closefile();
     return 1;
    }
  }
 closefile();
 return 0;
}

void main(int argc, char *argv[])

{
 int argcount;
 int cfgcount;

 screen=MK_FP(getpage(), 0);

 getrundir(argv[0]); // Rundir=path where config-file should be!

 printf("MultiConfig v1.1 - Copyright(C) 1994 by G. Veldman.\n\n");

 for (argcount=1;argcount<argc;argcount++)
  {
   if ((argv[argcount][0] == '/') || (argv[argcount][0] == '-'))
    {
     switch(toupper(argv[argcount][1]))
      {
       case '?': help();
                 exit(0);
       case 'H': help();
                 exit(0);
       case 'R': if (file_exists(configfile))
                  {
                   _chmod(configfile,1,0);
                   if (unlink(configfile))
                    {
                     printf("Error deleting configuration file.\n");
                     exit(1);
                    }
                   printf("Configuration file deleted.\n");
                  }
                 createconfigfile();
                 printf("New configuration file created.\n");
                 exit(0);
       case 'L': // Contents
                 checkconfigfile();
                 if (readconfigfile())
                  {
                   printf("Error reading configuration file.\n");
                   exit(1);
                  }
                 printf("%d configuration", header.configurations);
                 if (header.configurations!=1) printf("s");
                 printf(" known.\n\n");
                 printf("Nr.  Description                                         Short name\n");
                 for (cfgcount=0;cfgcount<header.configurations;cfgcount++)
                  {
                   printf("%03d  %-50s  %-16s\n", cfgcount+1, config[cfgcount].description, config[cfgcount].short_name);
                   if ((cfgcount+1) % 24 == 0)
                    {
                     printf("Press a key for more...");
                     if (getch() == 0) getch();
                     printf("\n");
                    }
                  }
                 exit(0);
       default:  printf("Unknown parameter %s. It will be ignored.\n\n", argv[argcount]);
      }
    }
  }

 // Check for config file exist
 checkconfigfile();
 // Read configuration file
 if (readconfigfile())
  {
   printf("Error reading configuration file.\n");
   exit(1);
  }
 // Check arguments
 if (argc==1)
  editconfig(); // Interactive-mode
 for (argcount=1;argcount<argc;argcount++)
  {
   if ((argv[argcount][0] == '/') || (argv[argcount][0] == '-')) goto next_config;
   if (checknumber(argv[argcount]))
    {
     if (atoi(argv[argcount]) == 0)
      {
       printf("Configuration numbers start at 1!\n");
       exit(1);
      }
     if (atoi(argv[argcount]) > header.configurations)
      {
       printf("Configuration number %s does not exist!\n", argv[argcount]);
       exit(1);
      }
     useconfiguration(atoi(argv[argcount])-1, BATCH);
    }
   else
    {
     for (cfgcount=0;cfgcount<header.configurations;cfgcount++)
      if (strcmp(strupr(config[cfgcount].short_name),strupr(argv[argcount]))==0)
       useconfiguration(cfgcount, BATCH);
     printf("Configuration %s not found!\n", argv[argcount]);
     exit(1);
    }
next_config:;
  }
}
